CREATE OR REPLACE FUNCTION load_to_table_function( tbl_date DATE, tbl_time TIME, file VARCHAR )
RETURNS BOOLEAN AS $$
DECLARE
    table_name CHAR(25);
BEGIN
    table_name := 'messages_' || to_char( (tbl_date + tbl_time)::TIMESTAMP , 'yyyy_mm_dd_hh24');
    IF NOT EXISTS( SELECT tablename FROM pg_tables WHERE tablename =  table_name ) THEN
	IF create_table_function(tbl_date, tbl_time) = FALSE THEN
	    RETURN FALSE;
	END IF;
    END IF;
    
    EXECUTE('COPY ' || table_name || '(ip, rtime, facsev, mtime, host, ident, pid, event, msg, fts) FROM ' || quote_literal(file) ||' DELIMITER '''' NULL AS ''NULL'' CSV QUOTE ''''');
    IF ( register_table( table_name, get_location_mask( 'database' ) ) = FALSE ) OR ( change_import_status(table_name, 'finished') = FALSE )  THEN
	RETURN FALSE;
    END IF;

    RETURN TRUE;
EXCEPTION
    WHEN OTHERS THEN
	PERFORM change_import_status(table_name, 'failed');
        RAISE NOTICE 'Error number:%', SQLSTATE;
        RETURN FALSE;
END;
$$
LANGUAGE plpgsql;
--UPDATE db VERSION
UPDATE service SET version = 3;
