<?php defined('SYSPATH') OR die('No direct access allowed.');

/**
 * Report options for historical logger reports
 */
class Logger_options extends Report_options
{
	public static $type = 'logger';

	protected $properties = array(
		'report_id' => array(
			'type' => 'int',
			'default' => false,
			'description' => 'Saved report id'
		),
		'report_name' => array(
			'type' => 'string',
			'default' => false,
			'description' => 'Name of the report'
		),
		'start_time' => array(
			'type' => 'string',
			'default' => 'today 00:00',
			'description' => 'Start time for report, as a date expression'
		),
		'end_time' => array(
			'type' => 'string',
			'default' => 'now',
			'description' => 'End time for report, as a date expression'
		),
		'query' => array(
			'type' => 'string',
			'default' => '[log_messages] all',
			'description' => 'A listfilter query'
		),
		'output_format' => array(
			'type' => 'enum',
			'default' => 'html',
			'options' => array(
				'html' => 'html',
				'csv' => 'csv',
				'pdf' => 'pdf'
			),
			'generated' => true,
			'description' => 'What type of report to generate (manually selected in web UI, generated from filename for saved reports)'
		),
	);

	public function setup_properties()
	{
		parent::setup_properties();
	}

	protected function update_value($name, $value)
	{
		switch($name) {
			case 'start_time':
			case 'end_time':
				$this->options[$name] = $value;
				return true;
		}
		return parent::update_value($name, $value);
	}
}
